#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <alloc.h>

//#define far
//#define farcalloc calloc

unsigned char far *H[301];
int N;
unsigned far *C[301];

struct entry
{
int i : 11;
int j : 11;
unsigned cost : 16;
};


#define nrbanks 11
#define bank 4096
#define bankp 12
#define bankm 4095

#define heap(a) (heapbanks[(a)>>bankp][(a)&bankm])
#define val(a) (heap(a).cost)

#define smaller(a, b) (val(a) < val(b) || (val(a) == val(b) && (heap(a).i+heap(a).j < heap(b).i+heap(b).j)))
#define sun(a) ((a)<<1 >= hs || smaller((a)<<1, ((a)<<1)+1) ? (a)<<1 : ((a)<<1)+1)


entry far *heapbanks[nrbanks];
unsigned hs;

entry _t;
inline void swap(unsigned i, unsigned j)
{
C[heap(i).i][heap(i).j] = j;
C[heap(j).i][heap(j).j] = i;
_t = heap(i);
heap(i) = heap(j);
heap(j) = _t;
}

void sift(unsigned i)
{
register unsigned p;
for (; i <= hs/2 && ((p = sun(i)) != 65535) && smaller(p, i); i = p)
swap(i, p);
}

void percolate(unsigned i)
{
for (; i > 1 && smaller(i, i/2); i /= 2)
swap(i, i/2);
}

inline void relax(unsigned cost, int oi, int oj, int i, int j)
{
if (i <= 0 || j <= 0 || i > N || j > N || C[i][j] == 65535) return;
if (H[i][j] > H[oi][oj])
cost += H[i][j] - H[oi][oj];


if (C[i][j] == 0)
{
++hs;
heap(hs).i = i;
heap(hs).j = j;
heap(hs).cost = 65535;
C[i][j] = hs;
}

if (heap(C[i][j]).cost > cost)
{
heap(C[i][j]).cost = cost;
percolate(C[i][j]);
}
}

void djikstra()
{
int i, j;
unsigned c, hsmax = 0;
heap(1).i = heap(1).j = 1;
heap(1).cost = 0;

C[1][1] = 1;
for (hs = 1; hs;)
{
if (hs > hsmax) hsmax = hs;
i = heap(1).i;
j = heap(1).j;
c = heap(1).cost;

if (i == N && j == N)
break;

if (hs > 1) swap(1, hs);
hs--;
sift(1);

C[i][j] = 65535;
relax(c, i, j, i+1, j);
relax(c, i, j, i-1, j);
relax(c, i, j, i, j+1);
relax(c, i, j, i, j-1);
}
FILE *fo = fopen("A.OUT", "wt");
fprintf(fo, "%u\n", c);
fclose(fo);
// printf("Cost: %u Heap size: %u \n", c, hsmax);
}

void read_data()
{
FILE *fi = fopen("A.IN", "rt");
int i, j, x;
fscanf(fi, "%d", &N);

for (i = 1; i <= N; i++)
{
H[i] = (unsigned char far *) farcalloc(N+1, sizeof(char));
C[i] = (unsigned far *) farcalloc(N+1, sizeof(unsigned));
}
for (i = 0; i < nrbanks; i++)
heapbanks[i] = (entry far *) farcalloc(bank, sizeof(entry));

for (i = 1; i <= N; i++)
for (j = 1; j <= N; j++)
{
fscanf(fi, "%d", &x);
H[i][j] = x; //(j % 2 == 0 && (i != ((j % 4 == 0) ? 1 : N))) ? 255 : 0;
}
fclose(fi);
}

void main()
{
read_data();
djikstra();
}
