{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{
Triangulizarea unui poligon oarecare (concav) in O(N^2) +
gasirea centrului de greutate al acestuia
}

{$N+,R-,Q-,I-}
{$M 65500,0,655360}

Program Placa_Metalica;

const filein='placa.in';
      fileout='placa.out';
      eps:double=1e-7;

type ppoly=^poly;
     poly=record
           x,y:double;
           urm,ant:ppoly;
          end;

var i,j,k,m,n,sens,sm,sm1:integer;
    start,aux,pred,next,next2,stnew,concav,v1,v2:ppoly;
    xx,yy,a,b,c,aa,bb,cc,xs,ys,sumaar,a2,b2,c2,rap:double;
    x1,y1,x2,y2,x3,y3,x4,y4,xi,yi,xg,yg,artr:double;
    convex,first:boolean;

function egal(r1,r2:double):boolean;
begin
egal:=(abs(r1-r2)<=eps);
end;

function semn(xa,ya,a,b,c:double):integer;
var ra:double;
begin
ra:=(xa*a+ya*b+c);
if (egal(ra,0)) then semn:=0
else if (ra>0) then semn:=1
     else semn:=-1;
end;

function inters(x4,y4:double):boolean;
begin
a2:=y3-y4;
b2:=x4-x3;
c2:=x3*y4-x4*y3;
rap:=a2*b-a*b2;

if (egal(rap,0.0)) then
  inters:=false
else
  begin
    xi:=(b2*c-b*c2)/rap;
    yi:=(c2*a-c*a2)/rap;

    if (
       (((xi>=x3) and (xi<=x4)) or
        ((xi>=x4) and (xi<=x3))) and
       (((yi>=y3) and (yi<=y4)) or
        ((yi>=y4) and (yi<=y3))) and
       (((xi>=x1) and (xi<=x2)) or
        ((xi>=x2) and (xi<=x1))) and
       (((yi>=y1) and (yi<=y2)) or
        ((yi>=y2) and (yi<=y1))) and
       ((not egal(xi,x1)) or (not egal(yi,y1))) and
       ((not egal(xi,x2)) or (not egal(yi,y2)))
       )
    then inters:=true
    else inters:=false;
  end;
end;

function intersect(varf:ppoly):boolean;
begin
x1:=concav^.x;
y1:=concav^.y;
x2:=stnew^.x;
y2:=stnew^.y;

x3:=varf^.x;
y3:=varf^.y;

intersect:=inters(varf^.ant^.x,varf^.ant^.y) or
           inters(varf^.urm^.x,varf^.urm^.y);
end;

procedure compute(strt:ppoly);
var l1,l2:ppoly;
begin
xx:=strt^.x;
yy:=strt^.y;
stnew:=strt;

aux:=strt^.urm;
while (aux<>strt) do
  begin
    if (aux^.x<xx) or
      ((egal(aux^.x,xx)) and (aux^.y<yy)) then
      begin
        xx:=aux^.x;
        yy:=aux^.y;
        stnew:=aux;
      end;

    aux:=aux^.urm;
  end;

pred:=stnew^.ant;
next:=stnew^.urm;

a:=stnew^.y-pred^.y;
b:=pred^.x-stnew^.x;
c:=(stnew^.x * pred^.y) - (pred^.x * stnew^.y);

if (semn(next^.x,next^.y,a,b,c)=-1) then
  sens:=1
else
  sens:=-1;

convex:=true;
concav:=nil;
aux:=stnew;

if (sens=-1) then
  next:=pred;

while (next<>stnew) do
  begin
    if (sens=1) then
      concav:=next^.urm
    else
      concav:=next^.ant;

    a:=aux^.y-next^.y;
    b:=next^.x-aux^.x;
    c:=(aux^.x * next^.y) - (next^.x * aux^.y);

    sm:=semn(concav^.x,concav^.y,a,b,c);

    if (sm=-1) then
      begin
        convex:=false;
        concav:=next;
        break;
      end;

    if (sens=1) then
      begin
        aux:=aux^.urm;
        next:=next^.urm;
      end
    else
      begin
        aux:=aux^.ant;
        next:=next^.ant;
      end;
  end;

if (convex) then
  begin
    aux:=stnew;
    next:=aux^.urm;
    next2:=next^.urm;

    x1:=aux^.x; y1:=aux^.y;
    x2:=next^.x; y2:=next^.y;

    while (next2<>aux) do
      begin
        x3:=next2^.x; y3:=next2^.y;

        xg:=(x1+x2+x3)/3; yg:=(y1+y2+y3)/3;

        artr:=0.5*abs(x1*y2-x2*y1+x2*y3-x3*y2+x3*y1-x1*y3);
        sumaar:=sumaar+artr;

        xs:=xs+(xg*artr); ys:=ys+(yg*artr);

        x2:=x3; y2:=y3;
        next2:=next2^.urm;
      end;
  end
else
  begin
    stnew:=nil;
    if (sens=1) then
      begin
        next:=concav^.urm;
        next2:=next^.urm;
      end
    else
      begin
        next:=concav^.ant;
        next2:=next^.ant;
      end;

    a:=concav^.y-next^.y;
    b:=next^.x-concav^.x;
    c:=(concav^.x*next^.y)-(concav^.y*next^.x);
    aa:=a; bb:=b; cc:=c;
    first:=true;

    while (next2<>concav) do
      begin
        sm:=semn(next2^.x,next2^.y,a,b,c);
        sm1:=semn(next2^.x,next2^.y,aa,bb,cc);

        if (sm1>0) and (sm=1) then
          begin
            if (first) then
              begin
                first:=false;
                stnew:=next2;

                a:=concav^.y-next2^.y;
                b:=next2^.x-concav^.x;
                c:=(concav^.x*next2^.y)-(concav^.y*next2^.x);
              end;
          end
        else
        if (sm1>=0) and (sm<=0) then
          begin

            if (not first) and (intersect(next2)) then
              begin
                stnew:=next2;
                a:=concav^.y-next2^.y;
                b:=next2^.x-concav^.x;
                c:=(concav^.x*next2^.y)-(concav^.y*next2^.x);
              end;
          end;

        if (sens=1) then
          next2:=next2^.urm
        else
          next2:=next2^.ant;
      end;

    l1:=concav;
    l2:=stnew;

    new(v1);
    move(concav^,v1^,sizeof(poly));
    new(v2);
    move(stnew^,v2^,sizeof(poly));

    stnew^.ant^.urm:=v2;
    v2^.ant:=stnew^.ant;
    v2^.urm:=concav;

    concav^.ant^.urm:=v1;
    v1^.ant:=concav^.ant;
    v1^.urm:=stnew;

    concav^.ant:=v2;
    stnew^.ant:=v1;

    compute(l1);
    compute(l2);
  end;
end;

begin
{ Read Data & Make Poly }
assign(input,filein);
reset(input);
readln(n);

new(start);
start^.urm:=nil;
start^.ant:=nil;
readln(xx,yy);
start^.x:=xx;
start^.y:=yy;
next:=start;

for i:=2 to n do
  begin
    readln(xx,yy);

    new(aux);
    aux^.x:=xx;
    aux^.y:=yy;
    aux^.urm:=nil;
    aux^.ant:=next;
    next^.urm:=aux;
    next:=aux;
  end;
start^.ant:=next;
next^.urm:=start;

close(input);
{ END Read Data & Make Poly }

{
sumaar:=0;
aux:=start;
next:=aux^.urm;
repeat
sumaar:=sumaar+(aux^.x*next^.y-aux^.y*next^.x);
aux:=aux^.urm;
next:=next^.urm;
until (aux=start);
sumaar:=0.5*abs(sumaar);
}

sumaar:=0;
xs:=0; ys:=0;
compute(start);

xs:=xs/sumaar;
ys:=ys/sumaar;

assign(output,fileout);
rewrite(output);
writeln(xs:0:4,' ',ys:0:4);
close(output);
end.