{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{
  Conform Teoremei lui VIZING, indicele cromatic al
  unui graf este K sau K+1, unde K este gradul maxim
  al unui nod din graf.

  Aceeasi teorema foloseste pentru a demonstra aceasta
  chiar un algoritm de colorare a muchiilor cu K sau
  K+1 culori.

  Este vorba chiar de algoritmul implementat in acest
  program :)
}

{$S-,I-,R-,Q-}
{$M 30000,0,655360}

Program Retea_de_calculatoare;

const filein='retea.in';
      fileout='retea.out';
      MAXN=160;

type vector=array[0..MAXN,0..MAXN] of byte;
     pvector=^vector;
     colorvect=array[0..1] of byte;

var list:array[0..MAXN,0..MAXN] of byte;
    fix:array[0..MAXN,0..MAXN] of boolean;
    used,marc:array[0..MAXN] of boolean;
    deg,path:array[0..MAXN] of byte;
    c:colorvect;
    num,color:pvector;
    i,j,k,m,n,p,q,cul,alfa,beta,act:integer;
    ok:boolean;

procedure invert(node:byte;c:colorvect);
var i1,j1,np,q,pp:byte;
begin
np:=0;
q:=0;
act:=node;

while (list[act,c[q]]>0) do
  begin
    inc(np);
    path[np]:=act;

    act:=list[act,c[q]];
    q:=(q+1) and 1;
  end;
inc(np);
path[np]:=act;

for pp:=1 to np-1 do
  begin
    q:=(pp-1) and 1;
    i1:=path[pp];
    j1:=path[pp+1];

    list[i1,c[q]]:=0;
    list[j1,c[q]]:=0;

    color^[i1,j1]:=c[(q+1) and 1];
    color^[j1,i1]:=c[(q+1) and 1];
  end;

for pp:=1 to np-1 do
  begin
    i1:=path[pp];
    j1:=path[pp+1];
    q:=color^[i1,j1];

    list[i1,q]:=j1;
    list[j1,q]:=i1;
  end;
end;

procedure insert(j:byte;alf:byte;keep:boolean);
var alfa,beta,p,q:byte;
    c:colorvect;
begin

if (not keep) then
  alfa:=255
else
  alfa:=alf;

beta:=254;
for p:=1 to k do
  begin
    if (not keep) and (list[i,p]=0) and (not used[p]) then
      alfa:=p;
    if (list[j,p]=0) and (not used[p]) then
      beta:=p;

    if (list[i,p]=0) and (list[j,p]=0) then
      begin
        alfa:=p;
        beta:=p;
      end;

    if (alfa=beta) then break;
  end;

if (alfa=beta) then
  begin
    list[i,alfa]:=j;
    list[j,alfa]:=i;
    color^[i,j]:=alfa;
    color^[j,i]:=alfa;
  end
else
  begin
    if (beta<254) then
      begin
        c[0]:=alfa;
        c[1]:=beta;
        act:=j;
        q:=0;

        while (list[act,c[q]]>0) do
          begin
            act:=list[act,c[q]];
            q:=(q+1) and 1;
          end;

        if (act<>i) then
          begin
            invert(j,c);

            list[i,alfa]:=j;
            list[j,alfa]:=i;
            color^[i,j]:=alfa;
            color^[j,i]:=alfa;
          end
        else
          begin
            act:=list[i,beta];
            list[act,beta]:=0;

            color^[i,act]:=0;
            color^[act,i]:=0;

            list[j,beta]:=i;
            list[i,beta]:=j;
            color^[i,j]:=beta;
            color^[j,i]:=beta;

            used[beta]:=true;
            insert(act,alfa,true);
          end;
      end
    else
      begin
        for p:=1 to k do
          if (list[j,p]=0) then
            begin
              beta:=p;
              break;
            end;

        c[0]:=alfa;
        c[1]:=beta;
        invert(j,c);

        list[i,alfa]:=j;
        list[j,alfa]:=i;
        color^[i,j]:=alfa;
        color^[j,i]:=alfa;
      end;
  end;
end;

begin
assign(input,filein);
reset(input);
assign(output,fileout);
rewrite(output);

fillchar(deg,sizeof(deg),0);
fillchar(list,sizeof(list),0);

new(num);
fillchar(num^,sizeof(vector),0);
new(color);
fillchar(color^,sizeof(color^),0);

readln(n);
while (not seekeof(input)) do
  begin
    readln(i,j);
    num^[i,j]:=1;
    num^[j,i]:=1;

    inc(deg[i]);
    inc(deg[j]);
  end;

k:=0;
for i:=1 to n do
  if (deg[i]>k) then
    k:=deg[i];
inc(k);

for i:=1 to n-1 do
  for j:=i+1 to n do
    if (num^[i,j]>0) then
      begin
        fillchar(used,sizeof(used),false);
        insert(j,0,false);
      end;

for i:=1 to n-1 do
  for j:=i+1 to n do
    if (num^[i,j]>0) then
      writeln(i,' ',j,' ',color^[i,j]);

close(output);
end.