Algoritmul Welzl rezolva aceasta problema in O(n). Toata chestia sta in randomizare. Este demonstrata (nu ma intrebati cum) aceasta complexitate. Rezolvarea pe care o stiam eu se baza pe existenta unui cerc suport care se tot marea si incerca sa le includa pe toate. Oricum, randomizarea este cheia.
In continuare o sursa de maxim(nu e ce stiam eu):

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

extern unsigned _stklen = 30000;

double far X[5010], far Y[5010];
double cx, cy, cr;

int far R[5010], Rn, Pn;

int intersect(double a1, double b1, double c1, double a2, double b2, double c2)
{
double num = a1*b2 - b1*a2;
if (fabs(num) < 1e-6) return 0;
cx = + (c2*b1 - c1*b2) / num;
cy = - (c2*a1 - c1*a2) / num;
return 1;
}

#define medx(a,b) ((X[R[a]] + X[R[b]]) / 2)
#define medy(a,b) ((Y[R[a]] + Y[R[b]]) / 2)
#define difx(a,b) (X[R[a]]-X[R[b]])
#define dify(a,b) (Y[R[a]]-Y[R[b]])

#define sqr(a) ((a)*(a))
#define dcircle(i) (sqr(X[i] - cx) + sqr(Y[i] - cy) - cr*cr)

int getcircle()
{
double a1, b1, c1, a2, b2, c2;
if (Rn == 0)
{
cx = cy = cr = 0;
return 1;
}
if (Rn == 1)
{
cx = X[R[0]];
cy = Y[R[0]];
cr = 0;
return 1;
}

if (Rn < 2) return 0;
if (Rn == 2)
{
cx = medx(0,1);
cy = medy(0,1);
cr = sqrt(difx(0,1)*difx(0,1) + dify(0,1)*dify(0,1)) / 2;
return 1;
}
a1 = difx(1,0);
b1 = dify(1,0);
c1 = - a1*medx(1,0) - b1*medy(1,0);
a2 = difx(2,0);
b2 = dify(2,0);
c2 = - a2*medx(2,0) - b2*medy(2,0);
if (!intersect(a1, b1, c1, a2, b2, c2)) return 0;
cr = sqrt(sqr(X[R[0]] - cx)+sqr(Y[R[0]] - cy));
for (int i = 3; i < Rn; i++)
if (fabs(dcircle(R[i])) > 1e-5) return 0;
return 1;
}


int _t;

double m;
int minidisk()
{
if (Pn == 0) return getcircle();
Pn--;
_t = minidisk();
if (_t && (dcircle(Pn) > 1e-5))
{
R[Rn++] = Pn;
_t = minidisk();
Rn--;
}
Pn++;
return _t;
}

void read_data()
{
int i, j;
double x, y;
FILE *fi = fopen("laden.in", "rt");
fscanf(fi, "%d", &Pn);
for (i = 0; i < Pn; i++)
{
fscanf(fi, "%lf %lf", &x, &y);
X[i] = x;
Y[i] = y;
}
for (i = 0; i < Pn-1; i++)
{
j = i + rand() % (Pn-i);
x = X[i], X[i] = X[j], X[j] = x;
y = Y[i], Y[i] = Y[j], Y[j] = y;
}
fclose(fi);
}

void print()
{
FILE *fo = fopen("laden.out", "wt");
fprintf(fo, "%.2lf\n%.2lf %.2lf\n", cr, cx, cy);
fclose(fo);
}

void main()
{
read_data();
minidisk();
print();
}
 