Problema impune cunoasterea unor smenuri foarte folositoare.
Sa presupunem cazul simplu, un vector. Pe acesta avem de facut multe update-uri (modificari), in masa (adica pe secvente). Aici sunt 2 feluri de a ataca problema:

Unul face update in sqrt(N), dar citirea este in O(1), in orice moment. Este cunoscut sub numele de Smenu' lu' Batog, desi nu are nici o legatura cu Bogdan, decat faptul ca de la el l-am aflat prima oara multi dintre noi.

Celalalt face update in O(1), dar citirea unei valori presupune intai o preprocesare de O(N).

La problema noastra doar a doua varianta era o solutie bune. Mai era inca un mic smen, legat de faptul ca nu era vector ci matrice. Update O(1), preprocesare O(N^2).

#include <stdio.h>

long A[105][105];
int N;


void update(int l1, int c1, int l2, int c2, long x)
{
A[l1][c1] += x;
A[l1][c2+1] -= x;
A[l2+1][c1] -= x;
A[l2+1][c2+1] += x;
}

void query()
{
int i, j;
for (i = 0; i <= N; i++)
for (j = 1; j <= N; j++)
A[i][j] += A[i][j-1];
for (j = 0; j <= N; j++)
for (i = 1; i <= N; i++)
A[i][j] += A[i-1][j];
}

void print()
{
FILE *fo = fopen("bursa.out", "wt");
int i, j;
for (i = 1; i <= N; i++, fprintf(fo, "\n"))
for (j = 1; j <= N; j++)
fprintf(fo, "%ld ", A[i][j]+100);
fclose(fo);
}


void read_data()
{
long m;
int l1, c1, l2, c2, x;
FILE *fi = fopen("bursa.in", "rt");
fscanf(fi, "%d %ld", &N, &m);
for (; m > 0; m--)
{
fscanf(fi, "%d %d %d %d %d", &l1, &c1, &l2, &c2, &x);
update(l1, c1, l2, c2, x);
}
fclose(fi);
}

void main()
{
read_data();
query();
print();
}  
