#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <assert.h>

typedef struct litem {
int f;
int m;
} litem;

litem far i_list[8192], far n_list[8192];
char far i_flags[8192], bitflags[4096];
char wflags[4096]; // far
int i_ndx[16], n_ndx[16], i_sz, n_sz; // far
litem f_list[8192]; // far
int f_sz;
int n, nc, ntms;

void gen_primes() {
litem nw;
int k;
int w, w0, w1, x, y, z;

f_sz = 0;

while(n_sz) {
i_sz = n_sz;
_fmemcpy(i_list, n_list, sizeof(litem) * i_sz);
memcpy(i_ndx, n_ndx, sizeof(i_ndx));
_fmemset(i_flags, 0, i_sz);
n_sz = 0;

n_ndx[0] = 0;
for(k = 0; k < n; k++) {
w = i_ndx[k + 1]; w0 = i_ndx[k];
w1 = i_ndx[k + 2];
for(x = w0; x < w; x++) {
for(y = w; y < w1; y++) {
if(i_list[x].f == i_list[y].f && bitflags[i_list[x].m ^ i_list[y].m]) {
nw.f = i_list[x].f ^ (i_list[x].m ^ i_list[y].m);
nw.m = i_list[x].m;
i_flags[x] = 1; i_flags[y] = 1;

for(z = n_ndx[k]; z < n_sz; z++) {
if(n_list[z].m == nw.m && n_list[z].f == nw.f)
break;
}
if(!(z < n_sz))
n_list[n_sz++] = nw;
}
}
}
n_ndx[k + 1] = n_sz;

for(x = w0; x < w; x++) {
if(!i_flags[x])
f_list[f_sz++] = i_list[x];
}
}
}
}

void gen_list() {
int x, y, z;
int m, mx;

// Step IIIa: reduce essential terms
i_sz = 0;
_fmemset(i_flags, 0, sizeof(i_flags));
for(x = 0; x < nc; x++) {
if(!wflags[x])
continue;

z = 0;
for(y = 0; y < f_sz; y++) {
if((f_list[y].f & x) == f_list[y].m)
z++;
}
if(z == 1) {
for(y = 0; y < f_sz; y++) {
if((f_list[y].f & x) == f_list[y].m)
break;
}
i_flags[y] = 1;
i_list[i_sz++] = f_list[y];
for(z = 0; z < nc; z++) {
if(wflags[z] && (f_list[y].f & z) == f_list[y].m) {
wflags[z] = 0;
ntms--;
}
}
}
}
z = 0;
for(x = 0; x < f_sz; x++) {
if(!i_flags[x]) {
f_list[z] = f_list[x];
z++;
}
}
f_sz = z;

_fmemset(i_flags, 0, sizeof(i_flags));

while(ntms) {
m = 0;
for(x = 0; x < f_sz; x++) {
if(i_flags[x])
continue;
z = 0;
for(y = 0; y < nc; y++) {
if(wflags[y] && (f_list[x].f & y) == f_list[x].m)
z++;
}
if(z > m) { m = z; mx = x; }
}
i_flags[mx] = 1;
i_list[i_sz++] = f_list[mx];

for(y = 0; y < nc; y++) {
if(wflags[y] && (f_list[mx].f & y) == f_list[mx].m) {
wflags[y] = 0;
ntms--;
}
}
}
}

int main() {
FILE *fp;
int x, y, z, k;
int tv;

// Step I : load initial list
fp = fopen("adevar.in", "rt");
fscanf(fp, "%d", &n);
nc = 1 << n;
i_sz = 0;
for(x = 0; x < nc; x++) {
fscanf(fp, "%d", &tv);
if(!tv)
continue;
i_list[i_sz].m = x;
i_list[i_sz].f = nc - 1;
i_sz++;
wflags[x] = 1;
ntms++;
}
fclose(fp);
// Step Ia: Sort inital list
n_sz = 0;
n_ndx[0] = 0;
for(k = 0; k <= n; k++) {
bitflags[1 << k] = 1;
for(x = 0; x < i_sz; x++) {
z = i_list[x].m;
y = 0;
while(z) {
y += z & 1;
z >>= 1;
}
if(y == k) {
n_list[n_sz].m = i_list[x].m;
n_list[n_sz].f = nc - 1;
n_sz++;
}
}
n_ndx[k + 1] = n_sz;
}

// Step II: we're ready for generating prime lists
gen_primes();

// Step III: generate final list
gen_list();

// Step IV: show up final results
fp = fopen("adevar.out", "wt");
for(x = 0; x < i_sz; x++) {
z = 'A' + n;
y = i_list[x].f;
k = i_list[x].m;
while(y) {
z--; 
if(y & 1)
fprintf(fp, (k & 1) ? "%c" : "_%c", z);
y >>= 1; k >>= 1;
}
fprintf(fp, (x < i_sz - 1) ? "+" : "\n");
}
fclose(fp);
return 0;
} 